# Method: projects.regions.clusters.create

- [HTTP request](https://docs.cloud.google.com/managed-spark/docs/reference/rest/v1/projects.regions.clusters/create#body.HTTP_TEMPLATE)
- [Path parameters](https://docs.cloud.google.com/managed-spark/docs/reference/rest/v1/projects.regions.clusters/create#body.PATH_PARAMETERS)
- [Query parameters](https://docs.cloud.google.com/managed-spark/docs/reference/rest/v1/projects.regions.clusters/create#body.QUERY_PARAMETERS)
- [Request body](https://docs.cloud.google.com/managed-spark/docs/reference/rest/v1/projects.regions.clusters/create#body.request_body)
- [Response body](https://docs.cloud.google.com/managed-spark/docs/reference/rest/v1/projects.regions.clusters/create#body.response_body)
- [Authorization scopes](https://docs.cloud.google.com/managed-spark/docs/reference/rest/v1/projects.regions.clusters/create#body.aspect)
- [FailureAction](https://docs.cloud.google.com/managed-spark/docs/reference/rest/v1/projects.regions.clusters/create#FailureAction)
- [Try it!](https://docs.cloud.google.com/managed-spark/docs/reference/rest/v1/projects.regions.clusters/create#try-it)

Creates a cluster in a project. The returned `https://docs.cloud.google.com/managed-spark/docs/reference/rest/v1/projects.locations.operations#Operation.FIELDS.metadata` will be [ClusterOperationMetadata](https://cloud.google.com/dataproc/docs/reference/rpc/google.cloud.dataproc.v1#clusteroperationmetadata).

### HTTP request

`POST https://dataproc.googleapis.com/v1/projects/{projectId}/regions/{region}/clusters`

The URL uses [gRPC Transcoding](https://google.aip.dev/127) syntax.

### Path parameters

| Parameters ||
|---|---|
| `projectId` | `string` Required. The ID of the Google Cloud Platform project that the cluster belongs to. Authorization requires the following [IAM](https://cloud.google.com/iam/docs/) permission on the specified resource `projectId`: - `dataproc.clusters.create` |
| `region` | `string` Required. The region in which to handle the request. |

### Query parameters

| Parameters ||
|---|---|
| `requestId` | `string` Optional. A unique ID used to identify the request. If the server receives two [CreateClusterRequest](https://cloud.google.com/dataproc/docs/reference/rpc/google.cloud.dataproc.v1#google.cloud.dataproc.v1.CreateClusterRequest)s with the same id, then the second request will be ignored and the first `https://docs.cloud.google.com/managed-spark/docs/reference/rest/v1/projects.locations.operations#Operation` created and stored in the backend is returned. It is recommended to always set this value to a [UUID](https://en.wikipedia.org/wiki/Universally_unique_identifier). The ID must contain only letters (a-z, A-Z), numbers (0-9), underscores (_), and hyphens (-). The maximum length is 40 characters. |
| `actionOnFailedPrimaryWorkers` | ``enum (`https://docs.cloud.google.com/managed-spark/docs/reference/rest/v1/projects.regions.clusters/create#FailureAction`)`` Optional. Failure action when primary worker creation fails. |

### Request body

The request body contains an instance of `https://docs.cloud.google.com/managed-spark/docs/reference/rest/v1/projects.regions.clusters#Cluster`.

### Response body

If successful, the response body contains a newly created instance of `https://docs.cloud.google.com/managed-spark/docs/reference/rest/v1/projects.locations.operations#Operation`.

### Authorization scopes

Requires one of the following OAuth scopes:

- `https://www.googleapis.com/auth/cloud-platform`
- `
  https://www.googleapis.com/auth/dataproc`

For more information, see the [Authentication Overview](https://docs.cloud.google.com/docs/authentication#authorization-gcp).

## FailureAction

Actions in response to failure of a resource associated with a cluster.

| Enums ||
|---|---|
| `FAILURE_ACTION_UNSPECIFIED` | When FailureAction is unspecified, failure action defaults to NO_ACTION. |
| `NO_ACTION` | Take no action on failure to create a cluster resource. NO_ACTION is the default. |
| `DELETE` | Delete the failed cluster resource. |